<template>
    <link href="https://unpkg.com/dropzone@6.0.0-beta.1/dist/dropzone.css" rel="stylesheet" type="text/css" />
    <div class="modal-background" id="outside_modal">
        <div class="exp-modal-wrapper" id="in_modal">
            <!-- Upload part -->
            <div class="exp-modal-box" style="display: flex; flex-direction: column;">
                <div class="exp-modal-box-headline">Upload data</div>
                <div v-if="edit_status == StudyModalStatus.Edit">Drag files here or click on the box to add files to your upload.</div>
                <div id="fileform" class="dropzone file-upload" v-if="edit_status == StudyModalStatus.Edit">
                </div>
                <div v-if="edit_status != StudyModalStatus.Edit">You don't have the necessary permissions to upload data.</div>
            </div>
            <!--Download part-->
            <div class="exp-modal-box">
                <div class="exp-modal-box-headline">Download data</div>
                <div v-for="file_to_dl in available_files" class="download-box">
                    <div class="available-file" @click="handleDownload(study_data!.study_id, file_to_dl.toString())">{{ file_to_dl }}</div>
                    <Icon icon="mdi:cancel-bold" width="30" height="30" color="var(--color-primary)" class="icon" 
                        @click="handleDeletion(study_data!.study_id, file_to_dl)"/>
                </div>
            </div>
            <div class="buttons" style="grid-column: 1 / 3;">
                <button v-if="edit_status == StudyModalStatus.Edit" @click="adding_conc = !adding_conc, adding_meta=false, adding_pheno=false">
                    {{ adding_conc ? "Close":"Set annotated conc. data"}}
                </button>
                <button v-if="edit_status == StudyModalStatus.Edit" @click="adding_pheno = !adding_pheno, adding_conc=false, adding_meta=false">
                    {{ adding_pheno ? "Close":"Set phenotype data"}}
                </button>
                <button v-if="edit_status == StudyModalStatus.Edit" @click="adding_meta = !adding_meta, adding_pheno=false, adding_conc=false">
                    {{ adding_meta ? "Close":"Add metadata from file"}}
                </button>
                <button @click="emit('back-to-study')">Back</button>
                <VueSpinnerGears v-if="loading" size="24" color="var(--color-primary)"></VueSpinnerGears>
            </div>
            <div class="add-data" v-if="adding_conc">
                Choose a concentration data file:
                <select v-model="conc_file">
                    <option v-for="file_to_dl in available_files.filter((s) => endsWithAny(s, ['.xls', '.xlsx', '.csv', '.tsv']))" :value="file_to_dl">{{ file_to_dl }}</option>
                </select>
                <div>Transpose rows and columns: <input type="checkbox" v-model="conc_transpose"></div>
                <button @click="addCD">Set</button>
                <div class="hint">This will completely replace any currently set concentration data.</div>
            </div>
            <div class="add-data" v-if="adding_pheno">
                Choose a phenotype data file:
                <select v-model="pheno_file">
                    <option v-for="file_to_dl in available_files.filter((s) => endsWithAny(s, ['.xls', '.xlsx', '.csv', '.tsv']))" :value="file_to_dl">{{ file_to_dl }}</option>
                </select>
                <div>Transpose rows and columns: <input type="checkbox" v-model="pheno_transpose"></div>
                <button @click="addPheno">Set</button>
                <div class="hint">This will completely replace any currently set concentration data.</div>
            </div>
            <div class="add-data" v-if="adding_meta">
                Choose a metadata file:
                <select v-model="meta_file">
                    <option v-for="file_to_dl in available_files.filter((s) => endsWithAny(s, ['.json', '.yml', '.yaml',]))" :value="file_to_dl">{{ file_to_dl }}</option>
                </select>
                <button @click="addMD">Set</button>
                <div class="hint">Metadata from this file will be merged with existing metadata.</div>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import { onMounted, ref, type PropType } from 'vue';
import { StudyModalStatus, type StudyData } from '@/stores/studies';
import { useAuthStore } from '@/stores/auth';
import { useMessageStore } from '@/stores/message';
import { addConcDataFromFile, addMetaDataFromFile, addPhenoDataFromFile, deleteExperimentalData, downloadExperimentalData, getStudyExperimentalFilenames, getStudyList } from '@/modules/study_module';
import Dropzone from 'dropzone';
import type { Message } from '@/stores/message';
import { Icon } from '@iconify/vue/dist/iconify.js';
import { VueSpinnerGears } from 'vue3-spinners';


const auth = useAuthStore();
const msg = useMessageStore();

const emit = defineEmits<{
    'close-modal': [],
    'back-to-study': [],
}>();

const addCD = async () => {
    if (!props?.study_data?.study_id || !conc_file.value) return;
    loading.value = true;
    let message:Message = await addConcDataFromFile(props?.study_data?.study_id, conc_file.value, conc_transpose.value);
    loading.value = false;
    msg.add_message(message);
    await getStudyList();
}

const addPheno = async () => {
    if (!props?.study_data?.study_id || !pheno_file.value) return;
    loading.value = true;
    let message:Message = await addPhenoDataFromFile(props?.study_data?.study_id, pheno_file.value, pheno_transpose.value);
    loading.value = false;
    msg.add_message(message);
    await getStudyList();
}

const addMD = async () => {
    if (!props?.study_data?.study_id || !meta_file.value) return;
    loading.value = true;
    let message:Message = await addMetaDataFromFile(props?.study_data?.study_id, meta_file.value);
    loading.value = false;
    msg.add_message(message);
    await getStudyList();
}

const props = defineProps({
    study_data: {} as PropType<StudyData>,
    edit_status: {} as PropType<StudyModalStatus>,
})

const adding_meta = ref<boolean>(false);
const adding_conc = ref<boolean>(false);
const adding_pheno = ref<boolean>(false);

const meta_file = ref<string>();
const pheno_file = ref<string>();
const conc_file = ref<string>();

const conc_transpose = ref<boolean>(false);
const pheno_transpose = ref<boolean>(false);

const loading = ref<boolean>(false);

const endsWithAny = (teststring: string, suffixes: string[]) => {
    for (let suffix of suffixes) {
        if(teststring.endsWith(suffix))
            return true;
    }
    return false;
}

/**
 * On mounting, sets values for inside and outside the modal and stores them.
 * Also initiates the dropzone which is used for uploading experimental data.
 */
 onMounted(async () => {
    initialized.value = false;
    if(document.getElementById("in_modal") && document.getElementById("in_modal") != undefined) {
        in_modal.value = document.getElementById("in_modal")
    }
    if(document.getElementById("outside_modal") && document.getElementById("outside_modal") != undefined) {
        outside_modal.value = document.getElementById("outside_modal")
    }
    initialized.value = true;
    available_files.value = (await getStudyExperimentalFilenames(props!.study_data!.study_id) as Message).body;
    dropzone.value = new Dropzone("div#fileform", {
        url: `${import.meta.env.VITE_BACKEND_PATH}UploadExperimentalData`,
        headers: {"Authorization": `Bearer ${auth.jwt ? auth.jwt : auth.aut}`},
        chunking: true,
        forceChunking: true,
        chunkSize: 10000000,
        paramName: "data",
        maxFilesize: 10000000,
        sending: function(file, xhr, formData) {
            formData.append("study_id", props!.study_data!.study_id)
        }
    })
    dropzone.value.on("success", async (file) => {
        available_files.value = (await getStudyExperimentalFilenames(props!.study_data!.study_id) as Message).body;
    });
    dropzone.value.on("error", (file, message) => {
        msg.add_message({status: 500, msg: (message as Message).msg});
    });
})

const handleDownload = async (study_id: string, filename: string) => {
    try {
        const potential_blob = await downloadExperimentalData(study_id, filename);
        if (potential_blob) {
            const link = document.createElement('a');
            link.href = URL.createObjectURL(potential_blob);
            link.download = filename;
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);

            URL.revokeObjectURL(link.href);
        }
    } catch (error) {
        console.error(error);
        msg.add_message({msg: "Sorry, your download failed!", status:500});
    }
    
}

const handleDeletion = async (study: string, filename: string) => {
    if (window.confirm(`Do you really want to delete the file ${filename}?`)) {
        const del_msg = await deleteExperimentalData(study, filename);
        msg.add_message(del_msg);
        available_files.value = (await getStudyExperimentalFilenames(props!.study_data!.study_id) as Message).body;
    } else return;
}

/**
 * Shows the modal if a user clicks inside the modal.
 * Closes it if a user clicks outside the modal.
 */
window.onclick = ((e: MouseEvent): void => {
    if (!initialized) {
        return;
    }
    if ((!in_modal.value || !outside_modal.value) || (e.target == outside_modal.value && e.target != in_modal.value)) {
        emit('close-modal')
    }
});

const in_modal=ref<HTMLElement | null>();
const outside_modal=ref<HTMLElement | null>();
const initialized=ref(false);
const dropzone = ref<Dropzone | null>(null);
const available_files = ref<string[]>([]);
</script>

<style scoped>

.add-data {
    width: 100%;
    display: flex;
    flex-direction: row;
    gap: 1rem;
    align-items: center;
    justify-content: center;
    grid-column: 1/3;
}

.exp-modal-wrapper {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-template-rows: 80% 10% 10%;
    min-width: 75%;
    width: 90%;
    max-width: 100%;
    padding: 1rem;
    background-color: #fff;
    margin: auto;
    box-shadow: var(--sd-larger);
    min-height: 65%;
    max-height: 90%;
}

.exp-modal-box {
    box-shadow: var(--sd-default);
    border: var(--bd-default);
    display: flex;
    align-items: center;
    flex-direction: column;
    overflow-y: auto;
    overflow-x: hidden;
    margin: 1rem;
}

.exp-modal-box-headline {
    font-weight: bold;
    font-size: var(--fs-large);
    color: var(--color-bg);
    background-color: var(--color-head);
    width: 100%;
    text-align: center;
    grid-column: 1 / 6;
    grid-row: 1;
}

.file-upload {
    margin: auto;
    padding: 1rem;
    border: var(--bd-default);
    width: 90%;
    text-align: left;
    box-shadow: var(--sd-default);
    overflow-y: scroll;
    margin-bottom: 1rem;
}

.available-file {
    color: var(--color-primary);
    cursor: pointer;
}

.download-box {
    width: 95%;
    margin-top: 0.25rem;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-items: baseline;
    justify-content: space-between;
}

.download-box:nth-of-type(2n) {
    background-color: var(--color-bg-alt);
}

.hint {
    font-size: 0.65rem;
    color: #7a7a7a;
}

</style>